.include "m8515def.inc"
;MasterAVR firmware
;Autor: Kovlev Lab, kovlev.ru
;v. 0.3

;PortA
.equ	iDir	= DDRC
.equ	iOut	= PORTC
.equ	iIn		= PINC
.equ	SDA		= 4
.equ	SCL		= 3
;PortD
.equ	PWR		= 7
.equ	CE		= 4
.equ	NOE		= 5		;      
.equ	OE		= 6		;

.equ	StackBegin		=RAMEND					; 
.equ	InitBaudRate	=3				; 7372800/16/115200-1	;UART on 115200
;.equ	InitBaudRate	=5				;11059200/16/115200-1	;UART on 115200

;   
.equ	CMD_SENDID					=0x69
.equ	CMD_POWER					=0x50
.equ	CMD_AT24READPAGEBIG			=0x53
.equ	CMD_AT24WRITEBUFFERBIG		=0x01
.equ	CMD_AT24ISCLEARBIG			=0x3F
.equ	CMD_AT24READPAGESMALL		=0x54
.equ	CMD_AT24WRITEBUFFERSMALL	=0x02
.equ	CMD_AT24GETCSBIG			=0x4B
.equ	CMD_AT24GETCSSMALL			=0x4A
.equ	CMD_AT24ISCLEARSMALL		=0x3E
.equ	CMD_AT27READPAGE			=0x72
.equ	CMD_AT27GETCS				=0x4C
.equ	CMD_AT27ISCLEAR				=0x2F

.equ	CMD_AT27WRITEBUFFER			=0x77


;
;.def	CS1			=R0
;.def	CS2			=R1
;.def	CS3			=R2
.def	CS1			=R3		;temporary register
.def	CS2			=R4		;temporary register
.def	CS3			=R5		;temporary register
.def	temp3			=R6		;
.def	temp4			=R7		;
;.def	8			=R8
;.def	9			=R9
;.def	10			=R10
;.def	11			=R11
;.def	12			=R12
;.def	13			=R13
;.def	14			=R14
;.def	TmpSREG		=R15


.def	temp0		=R16		;temporary register
.def	temp1		=R17		;temporary register
.def	temp2		=R18		;temporary register
.def	cntL		=R19		;temporary register
.def	cntH		=R20		;temporary register


;CMD ADDR_HI ADDR_LOW VAL RSV ADR SUMM
.def	ADR			=R21		;  .
.def	CMD			=R22		;
.def	VAL			=R23		;  /
.def	ADDR_LOW	=R24		;,  
.def	ADDR_HI		=R25		;,  
;r26	XH
;r27	XL
;r28	YH
;r29	YL
;r30	ZH
;r31	ZL


.macro  jmpeq
	cpi		@0, @1
	brne	PC+2
	rjmp	@2
.endmacro

 	.dseg
	.org	0x60
BufferBegin:		.byte	64

;------------------------------------------------------------------------------------------
;********************************************************************
;* Interrupt table	;ENG;* Interrupt table
;********************************************************************
.cseg
;------------------------------------------------------------------------------------------
.org 0						;reset
	rjmp	Reset
;------------------------------------------------------------------------------------------
Reset:		
	; , 
	ldi		temp0, HIGH(StackBegin)	;    
	out		SPH, temp0
	ldi		temp0, LOW(StackBegin)
	out		SPL, temp0
	rcall	PortInit

	rjmp	test1



;---------------------------------------------------------------
;Main program
Main:
	rcall	GetChar
	mov		CMD, temp0
	rcall	GetChar
	mov		ADDR_HI, temp0
	rcall	GetChar
	mov		ADDR_LOW, temp0
	rcall	GetChar
	mov		VAL, temp0
	rcall	GetChar
	mov		ADR, temp0


	;,    

	jmpeq	CMD, CMD_SENDID, SendDeviceID
	jmpeq	CMD, CMD_POWER, Power
	jmpeq	CMD, CMD_AT24READPAGEBIG, DoAT24ReadPage
	jmpeq	CMD, CMD_AT24WRITEBUFFERBIG, DoAT24WriteBuffer
	jmpeq	CMD, CMD_AT24ISCLEARBIG, DoAT24IsClearBig
	jmpeq	CMD, CMD_AT24READPAGESMALL, DoAT24ReadPageSmall
	jmpeq	CMD, CMD_AT24WRITEBUFFERSMALL, DoAt24WriteBufferSmall
	jmpeq	CMD, CMD_AT24GETCSBIG, DoAT24GetCSBig
	jmpeq	CMD, CMD_AT24GETCSSMALL, DoAT24GetCSSmall
	jmpeq	CMD, CMD_AT24ISCLEARSMALL, DoAT24IsClearSmall
	jmpeq	CMD, CMD_AT27READPAGE, DoAT27ReadPage
	jmpeq	CMD, CMD_AT27GETCS, DoAT27GetCS
	jmpeq	CMD, CMD_AT27ISCLEAR, DoAT27IsClear
	jmpeq	CMD, CMD_AT27WRITEBUFFER, DoAt27WriteBuffer
	rjmp	UnknownCommand


;-----------------------------------------------------------------
PortInit:
	;  PORTA=0, PORTB,PORTC,PORTD=255
	ldi		temp0,0xFF
	out		DDRA, temp0		;  
	out		DDRB, temp0		;  
	out		DDRC, temp0		;C  
	out		DDRD, temp0		;D  
	ldi		temp0,0x0
	out		PORTA, temp0	; .   
	out		PORTC, temp0	; .   
	out		PORTB, temp0	; .  
	ldi		temp0, 0b11000000
	out		PORTD, temp0

	sbi		PORTD, OE
	cbi		PORTD, NOE
	sbi		PORTD, PWR
	cbi		PORTD, CE
	
	;   
;	ldi		temp0,0b00011000	;  , 8 
;	out		UCR,temp0
	ldi		temp0, (1<<RXEN)|(1<<TXEN)
	out 	UCSRB,temp0
	; Set frame format: 8data, 2stop bit
	ldi 	temp0, (1<<URSEL)|(1<<UCSZ0)|(1<<UCSZ1)
	out 	UCSRC,temp0

	clr		temp0
	out		UBRRH,temp0		;   (115200 )
	ldi		temp0, InitBaudRate
	out		UBRRL,temp0		;   (115200 )
	ret
;--------------------------------------------------------------------------
Power:
	cpi		VAL, 1
	breq	POW_ON	
POW_OFF:
	sbi		PORTD, PWR
	rcall	Del_10t
	ldi		VAL, 1
	sbic	PIND, PWR
	ldi		VAL, 0
	rcall	PortInit
	rjmp	PWN
POW_ON:
	cbi		PORTD, PWR
	rcall	Del_10t
	ldi		VAL, 0
	sbic	PIND, PWR
	ldi		VAL, 1
PWN:
	mov		temp0, CMD
	rcall	SendChar
	mov		temp0, VAL
	rcall	SendChar
	rcall	SendChar
	rcall	SendChar
	rjmp	Main
;--------------------------------------------------------------------------
DoAT24GetCSBig:
	rcall	At24GetCSBig
	brcs	DoErrR
	rjmp	Main
;--------------------------------------------------------------------------
DoAT24IsClearBig:
	rcall	At24IsClearBig
	brcs	DoErrR
	rjmp	Main
;--------------------------------------------------------------------------
DoAT24GetCSSmall:
	rcall	At24GetCSSmall
	brcs	DoErrR
	rjmp	Main
;--------------------------------------------------------------------------
DoAT24IsClearSmall:
	rcall	At24IsClearSmall
	brcs	DoErrR
	rjmp	Main
;--------------------------------------------------------------------------
DoAT24ReadPage:
	rcall	At24ReadPage
	brcs	DoErrR
	rjmp	Main
;--------------------------------------------------------------------------
DoAT27ReadPage:
	rcall	At27ReadPage
	rjmp	Main
;--------------------------------------------------------------------------
DoAT27GetCS:
	rcall	At27GetCS
	rjmp	Main
;--------------------------------------------------------------------------
DoAT27IsClear:
	rcall	At27IsClear
	rjmp	Main
;--------------------------------------------------------------------------
DoAT27WriteBuffer:
	ldi		cntL, 32
	rcall	LoadInBuffer
	rcall	At27WriteBuffer
	rjmp	Main
;--------------------------------------------------------------------------
DoAT24ReadPageSmall:
	rcall	At24ReadPageSmall
	brcs	DoErrR
	rjmp	Main
;--------------------------------------------------------------------------
; cntL  
LoadInBuffer:
	ldi		XL, low(BufferBegin)
	ldi		XH, high(BufferBegin)
GetNextByte:
	rcall	GetChar
	st		X+, temp0	;
	dec		cntL
	brne	GetNextByte
	ret
;--------------------------------------------------------------------------
DoAT24WriteBuffer:
	ldi		cntL, 32
	rcall	LoadInBuffer
	rcall	At24WriteBuffer
	brcs	DoErrW
	rjmp	Main
;-----------------------------------------------------------------
DoAt24WriteBufferSmall:				;   8 
	ldi		cntL, 16
	rcall	LoadInBuffer
	rcall	At24WriteBufferSmall	; 
	brcs	DoErrW
	rjmp	Main
;-----------------------------------------------------------------
;-----------------------------------------------------------------
DoErrR:
	ldi		temp0, 0x55
	rcall	SendChar
	rcall	SendChar
	rcall	SendChar
	rjmp	Reset
;-----------------------------------------------------------------
DoErrW:
	ldi		temp0, 0xAA
	rcall	SendChar
	rcall	SendChar
	rcall	SendChar
	rjmp	Reset
;-----------------------------------------------------------------
Del_1s:
	ldi		temp2, 0xFF
D2:	rcall	Del_1ms
	rcall	Del_1ms
	rcall	Del_1ms
	rcall	Del_1ms
	dec		temp2
	brne	D2
	ret
;-----------------------------------------------------------------
Del_1ms:	;  1  (246  4.05  7.3728MHz)
	ldi		temp1, 0xF6
D1:	rcall	Del_10t
	rcall	Del_10t
	rcall	Del_10t
	dec		temp1
	brne	D1
	ret
;-----------------------------------------------------------------
Del_100mks:	;  100 
	ldi		temp1, 0x3D
D3:	rcall	Del_10t
	dec		temp1
	brne	D3
	ret
;-----------------------------------------------------------------
Del_10t:	;  10  - 1.35  7.3728MHz
	nop
	nop
	nop
	ret
;-----------------------------------------------------------------
SendDeviceID:
	ldi		ZH, high(DeviceID<<1)		;   
	ldi		ZL, low(DeviceID<<1)
	ldi		temp1, 20
SendDeviceID_1:
	lpm
	mov		temp0, r0
	rcall	SendChar
	adiw	ZH:ZL,1
	dec		temp1
	brne	SendDeviceID_1
	rjmp	Main
;-----------------------------------------------------------------
UnknownCommand:
	rcall	PortInit
	mov		temp1, temp0
	mov		temp0, CMD
	rcall	SendChar
	ldi		temp0, 0x55
	rcall	SendChar
	ldi		temp0, 0x00
	rcall	SendChar
	rcall	SendChar
	rcall	SendChar
	mov		temp0, temp1
	rcall	SendChar
	rjmp	Main
;-----------------------------------------------------------------
SendChar:
	sbis	UCSRA,UDRE		;    
	rjmp	SendChar
	out		UDR,temp0		;  
	ret
;-----------------------------------------------------------------                                                                 
GetChar:
	sbis	UCSRA,RXC			;   

	rjmp	GetChar
	in		temp0,UDR		;  
	clc
	sbic	UCSRA,FE			;  , 
	sec						;  C
	ret
;-----------------------------------------------------------------
test1:
	sbi		PORTD, NOE		; +12
	rcall	Del_100mks		;  100
	cbi		PORTD, NOE		; +12
	rcall	Del_100mks	;  100 
	rjmp	test1

;-----------------------------------------------------------------
DeviceID:
	.db		"Master AVR v.0.3    "
DeviceIDEnd:
;-----------------------------------------------------------------

.include "At24.asm"
.include "At27.asm"

