;-----------------------------------------------------------------
;PowerOn24cXXX:
;	cbi		DDRA, PA6
;	sbi		PORTA, PA6		;    Q6
;	rcall	Del_1ms
;	cbi		PORTB, PB1		; +12  +5  ,  ""
;	cbi		PORTB, PB0		; +5  24cXXX
;	rcall	Del_1ms
;
;	ldi		temp0, 0b00111111
;	out		DDRA, temp0
;	ldi		temp0, 0b01011000
;	out		PORTA, temp0
;	ret
;-----------------------------------------------------------------
;PowerOff24cXXX:
;	sbi		PORTB, PB0		; +5  24cXXX
;	sbi		PORTB, PB1		; +12  +5  ,  ""
;
;	rcall	Del_1ms
;
;	ldi		temp0, 0xFF
;	out		DDRA, temp0		;  
;	ldi		temp0, 0
;	out		PORTA, temp0	;     . 24XXX
;	ret
;-----------------------------------------------------------------

;-----------------------------------------------------------------
DelayI2C:
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	ret
;-----------------------------------------------------------------
; I2C,  SCL, SDA  0.    
I2C_Start:
	sbi		iOut, SDA		; SDA  1
	sbi		iOut, SCL		; SCL  1
	cbi		iDir, SDA		; SDA  
	cbi		iDir, SCL		; SCL  
	sbis	iIn, SDA		; SDA = 0
	rjmp	ErrStart		; ,  
	sbis	iIn, SCL		; SCL = 0
	rjmp	ErrStart		; ,  
	sbi		iDir, SDA		;c  SDA  
	sbi		iDir, SCL		;  SCL  
rcall	Del_10t
	cbi		iOut, SDA		; SDA  0
rcall	Del_10t
	cbi		iOut, SCL		; SCL  0
	clc						;   
	rjmp	NoErrStart
ErrStart:
	sec						;  
NoErrStart:
rcall	Del_10t
	ret						;
;-----------------------------------------------------------------
; I2C,  SCL, SDA  1
I2C_Stop:
	cbi		iOut, SDA		; SDA
	rcall	Del_10t
	sbi		iOut, SCL		; SCL  .1
	rcall	Del_10t
	sbi		iOut, SDA		; SDA  .1
	ret						;
;-----------------------------------------------------------------
;   temp0  I2C.    
I2C_Out:
	rcall	DelayI2C
	ldi		temp1, 8		; 
sNextOutBit:
	rcall	DelayI2C
	rol		temp0			;     
	brcs	sSetb_SDA		; =1,     SDA 1
	cbi		iOut, SDA		;   SDA 0
	rjmp	sPulseSCL		;   SCL
sSetb_SDA:
	sbi		iOut, SDA		;  SDA 1
sPulseSCL:
	rcall	DelayI2C
	sbi		iOut, SCL		;  SCL
	rcall	DelayI2C
	cbi		iOut, SCL		;
	rcall	DelayI2C
	dec		temp1			;  
	brne	sNextOutBit		;  Z  ,    
	rcall	DelayI2C
	cbi		iDir, SDA		; SDA  
	sbi		iOut, SDA		; .  
	rcall	DelayI2C
	sbi		iOut, SCL		;  SCL
	rcall	DelayI2C

	sbis	iIn, SDA		; SDA = 1   =1
	rjmp	sClearC			;    
	rcall	DelayI2C
	sec						; ,   
	rjmp	sNext3			;
	rcall	DelayI2C
sClearC:
	clc						; ,  
sNext3:
	rcall	DelayI2C
	cbi		iOut, SCL		;  SCL
	rcall	DelayI2C
	sbi		iDir, SDA		; SDA  
	cbi		iOut, SDA		; SDA  .1
	ret						;
;-----------------------------------------------------------------
;   I2C  temp0.    
I2C_In:
	rcall	DelayI2C
	ldi		temp1, 8		; 
	cbi		iDir, SDA		; SDA  
	sbi		iOut, SDA		; .  
sNextInBit:
	rcall	DelayI2C
	sbi		iOut, SCL		;  SCL
	rcall	DelayI2C
	sec						; 
	sbis	iIn, SDA		; SDA = 1   =1
	clc						; 
	rol		temp0			;  temp0    
	cbi		iOut, SCL		;  SCL
	rcall	DelayI2C
	dec		temp1			; 
	brne	sNextInBit		;  Z  ,    
	sbi		iDir, SDA		; SDA  
	rcall	DelayI2C
	ret						;
;-----------------------------------------------------------------

;-----------------------------------------------------------------
;   
I2C_Ack:
	cbi		iOut, SDA
	sbi		iOut, SCL
	rcall	Del_10t
	cbi		iOut, SCL
	ret
;-----------------------------------------------------------------
; 
I2C_Nak:
	sbi		iOut, SDA
	sbi		iOut, SCL
	rcall	Del_10t
	cbi		iOut, SCL
	ret
;-----------------------------------------------------------------
At24GetCSStart:
	clr		CS1			;  
	clr		CS2
	clr		CS3
	mov		XH, ADDR_HI		;   XH:XL   .
	mov		XL, ADDR_LOW
	ret
;-----------------------------------------------------------------
At24GetCSBig:
	rcall	At24GetCSStart

	rcall	I2C_Start		; 
	brcs	GetCS_Err

	mov		temp0, ADR		;  
	rcall	I2C_Out
	brcs	GetCS_Err

	ldi		temp0, 0	;  0000
	rcall	I2C_Out
	brcs	GetCS_Err

	ldi		temp0, 0
	rcall	I2C_Out
	brcs	GetCS_Err

	rjmp	At24GetCSCommon
;-----------------------------------------------------------------
At24GetCSSmall:
	rcall	At24GetCSStart

	rcall	I2C_Start		; 
	brcs	GetCS_Err

	mov		temp0, ADR		;  , 
	rcall	I2C_Out			;     
	brcs	GetCS_Err

	ldi		temp0, 0		;  0000
	rcall	I2C_Out
	brcs	GetCS_Err
	rjmp	At24GetCSCommon
;-----------------------------------------------------------------
At24GetCSCommon:
	rcall	I2C_Start		;  
	brcs	GetCS_Err

	mov		temp0, ADR		;  
	ori		temp0, 1		; .   
	rcall	I2C_Out
	brcs	GetCS_Err
GetCSNext:
	rcall	I2C_In			; 
	clc		;c Carry	; 
	add		CS1, temp0
	clr		temp0
	adc		CS2, temp0
	adc		CS3, temp0
	clc						; 
GetCSNext1:

	sbiw	XH:XL, 1
	brne	GetCSAck

	rcall	I2C_Nak			;  
GetCS_NoErr:
	clc
GetCS_Err:
	rcall	I2C_Stop

	mov		temp0, CMD
	rcall	SendChar
	ldi		temp0, 0
	rcall	SendChar
	mov		temp0, CS1
	rcall	SendChar
	mov		temp0, CS2
	rcall	SendChar
	mov		temp0, CS3
	rcall	SendChar
	mov		temp0, ADDR_HI
	rcall	SendChar
	mov		temp0, ADDR_LOW
	rcall	SendChar

	ret						;

GetCSAck:
	rcall	I2C_Ack			;   
	rjmp	GetCSNext		;   
;-----------------------------------------------------------------
At24IsClearStart:
	mov		XH, ADDR_HI		;   XH:XL   .
	mov		XL, ADDR_LOW
	clr		YH
	clr		YL
	ret
;-----------------------------------------------------------------
At24IsClearBig:
	rcall	At24IsClearStart

	rcall	I2C_Start		; 
	brcs	IsClear_Err

	mov		temp0, ADR		;  
	rcall	I2C_Out
	brcs	IsClear_Err

	ldi		temp0, 0	;  0000
	rcall	I2C_Out
	brcs	IsClear_Err

	ldi		temp0, 0
	rcall	I2C_Out
	brcs	IsClear_Err
	rjmp	At24IsClearCommon
;-----------------------------------------------------------------
At24IsClearSmall:
	rcall	At24IsClearStart

	rcall	I2C_Start		; 
	brcs	IsClear_Err

	mov		temp0, ADR		;  
	rcall	I2C_Out
	brcs	IsClear_Err

	ldi		temp0, 0	;  0000
	rcall	I2C_Out
	brcs	IsClear_Err
;-----------------------------------------------------------------
At24IsClearCommon:
	rcall	I2C_Start		;  
	brcs	IsClear_Err
	mov		temp0, ADR		;  
	ori		temp0, 1		; .   
	rcall	I2C_Out
	brcs	IsClear_Err
IsClearNext:
	rcall	I2C_In			; 
	cpi		temp0, 0xFF
	brne	NotClear
	adiw	YH:YL, 1		; 
	sbiw	XH:XL, 1
	brne	IsClearAck
	ldi		temp2, 0x43
IsClearEnd:
	rcall	I2C_Nak			;  
IsClear_NoErr:
	clc
IsClear_Err:
	rcall	I2C_Stop
	mov		VAL, temp0
;	mov		temp0, CMD
;	rcall	SendChar
	mov		temp0, temp2 
	rcall	SendChar
	mov		temp0, YH
	rcall	SendChar
	mov		temp0, YL
	rcall	SendChar
	mov		temp0, VAL
	rcall	SendChar
	ret						;

NotClear:
	ldi		temp2, 0x44
	rjmp	IsClearEnd
	
IsClearAck:
	rcall	I2C_Ack			;   
	rjmp	IsClearNext		;   
;-----------------------------------------------------------------
At24ReadPage:
	ldi		cntL, 255
	ldi		ADDR_LOW, 0
	mov		ADDR_HI, VAL	;  

	rcall	I2C_Start		; 
	brcs	ReadBuffer_Err

	mov		temp0, ADR		;  
	rcall	I2C_Out
	brcs	ReadBuffer_Err

	mov		temp0, ADDR_HI	;  
	rcall	I2C_Out
	brcs	ReadBuffer_Err

	mov		temp0, ADDR_LOW	;  
	rcall	I2C_Out
	brcs	ReadBuffer_Err

	rcall	I2C_Start		;  
	brcs	ReadBuffer_Err
	mov		temp0, ADR		;  
	ori		temp0, 1		; .   
	rcall	I2C_Out
	brcs	ReadBuffer_Err

	rcall	I2C_In			; 
	rcall	SendChar

ReadBufferNext:
	rcall	Del_10t
	rcall	I2C_Ack			;   
	rcall	I2C_In			;   
	rcall	SendChar
	cpi		cntL, 1		;    
	brne	BufferNextByte		;    , 
	rcall	I2C_Nak			; 
	rjmp	ReadBuffer_NoErr
BufferNextByte:
	dec		cntL
	brne	ReadBufferNext		;  Z  ,    
ReadBuffer_NoErr:
	clc
ReadBuffer_Err:
	rcall	I2C_Stop
	ret						;
;-----------------------------------------------------------------
At24WriteBuffer:

	ldi		XL, low(BufferBegin)
	ldi		XH, high(BufferBegin)
	ldi		cntL, 32

	rcall	I2C_Start		; 
	brcs	WriteBuffer_Err

	mov		temp0, ADR		;  
	rcall	I2C_Out
	brcs	WriteBuffer_Err

	mov		temp0, ADDR_HI	;  
	rcall	I2C_Out
	brcs	WriteBuffer_Err

	mov		temp0, ADDR_LOW	;  
	rcall	I2C_Out
	brcs	WriteBuffer_Err

NextWriteByte:
	ld		temp0, X+
	rcall	I2C_Out
	brcs	WriteBuffer_Err
	rcall	Del_10t
	dec		cntL				;    
	brne	NextWriteByte		;  Z  ,    

;	ldi		XL, low(BufferBegin)
;	ldi		XH, high(BufferBegin)
;	ldi		cntL, 64
;	rcall	I2C_Start		; 
;	brcs	WriteBuffer_Err
;
;	mov		temp0, ADR		;  
;	rcall	I2C_Out
;	brcs	WriteBuffer_Err
;
;	mov		temp0, ADDR_HI	;  
;	rcall	I2C_Out
;	brcs	WriteBuffer_Err
;
;	mov		temp0, ADDR_LOW	;  
;	rcall	I2C_Out
;	brcs	WriteBuffer_Err
;
;	rcall	I2C_Start		;  
;	brcs	WriteBuffer_Err
;	mov		temp0, ADR		;  
;	ori		temp0, 1		; .   
;	rcall	I2C_Out
;	brcs	WriteBuffer_Err
;
;	rcall	I2C_In			; 
;	ld		cntH, X+
;	cp		temp0, cntH
;	brne	SendWrite_Err
;
;CompareBufferNext:
;	rcall	Del_10t
;	rcall	I2C_Ack			;   
;	rcall	I2C_In			;   
;	ld		cntH, X+
;	cp		temp0, cntH
;	brne	SendWrite_Err
;	cpi		cntL, 1		;    
;	brne	CompareNext		;    , 
;	rcall	I2C_Nak			; 
;	rjmp	Compare_NoErr
;CompareNext:
;	dec		cntL
;	brne	CompareBufferNext		;  Z  ,    
;Compare_NoErr:
	clc
	ldi		temp0, 0
	rcall	SendChar
	rcall	SendChar
WriteBuffer_Err:
	rcall	I2C_STOP
//	rcall	Del_1ms
	ret						;
;SendWrite_Err:
;	ldi		temp0, 0x77
;	rcall	SendChar
;	rcall	SendChar
;	rjmp	WriteBuffer_Err
;-----------------------------------------------------------------
At24ReadPageSmall:
	ldi		cntL, 255

	rcall	I2C_Start		; 
	brcs	ReadBufferSmall_Err

	mov		temp0, ADR		;  , 
	rcall	I2C_Out			;     
	brcs	ReadBufferSmall_Err

	mov		temp0, ADDR_LOW		;  
	rcall	I2C_Out
	brcs	ReadBufferSmall_Err

	rcall	I2C_Start		;  
	brcs	ReadBufferSmall_Err
	mov		temp0, ADR		;  
	ori		temp0, 1		; .   
	rcall	I2C_Out
	brcs	ReadBufferSmall_Err

	rcall	I2C_In			; 
	rcall	SendChar

ReadBufferNextSmall:
	rcall	Del_10t
	rcall	I2C_Ack			;   
	rcall	I2C_In			;   
	rcall	SendChar
	cpi		cntL, 1		;    
	brne	BufferNextByteSmall		;    , 
	rcall	I2C_Nak			; 
	rjmp	ReadBufferSmall_NoErr
BufferNextByteSmall:
	dec		cntL
	brne	ReadBufferNextSmall		;  Z  ,    
ReadBufferSmall_NoErr:
	clc
ReadBufferSmall_Err:
	rcall	I2C_Stop
	ret						;
;-----------------------------------------------------------------
At24WriteBufferSmall:
	ldi		temp0, low(BufferBegin+8)
	mov		XL, temp0
	ldi		temp0, high(BufferBegin+8)
	mov		XH, temp0
	ldi		cntL, 8

	rcall	I2C_Start		; 
	brcs	WriteBufferSmall_Err

	mov		temp0, ADR		;  
	rcall	I2C_Out
	brcs	WriteBufferSmall_Err

	mov		temp0, ADDR_LOW	;  
	rcall	I2C_Out
	brcs	WriteBufferSmall_Err

NextWriteByteSmall:
	ld		temp0, X+
	rcall	I2C_Out
	brcs	WriteBufferSmall_Err
	rcall	Del_10t
	dec		cntL				;    
	brne	NextWriteByteSmall		;  Z  ,    
	rjmp	WriteBufferSmall_NoErr
WriteBufferSmall_NoErr:
	clc
	rcall	I2C_STOP
	rcall	Del_1ms

;CompareBegin:
;	ldi		XL, low(BufferBegin)
;	ldi		XH, high(BufferBegin)
;	ldi		cntL, 8
;
;	rcall	I2C_Start		; 
;	brcs	WriteBufferSmall_Err
;
;	mov		temp0, ADR		;  , 
;	rcall	I2C_Out			;     
;	brcs	WriteBufferSmall_Err
;
;	mov		temp0, ADDR_LOW		;  
;	rcall	I2C_Out
;	brcs	WriteBufferSmall_Err
;
;	rcall	I2C_Start		;  
;	brcs	WriteBufferSmall_Err
;	mov		temp0, ADR		;  
;	ori		temp0, 1		; .   
;	rcall	I2C_Out
;	brcs	WriteBufferSmall_Err
;
;	rcall	I2C_In			; 
;	st		X+, temp0
;
;CompareBufferNextSmall:
;	rcall	Del_10t
;	rcall	I2C_Ack			;   
;	rcall	I2C_In			;   
;	st		X+, temp0
;	cpi		cntL, 1		;    
;	brne	CompareBufferNextByteSmall		;    , 
;	rcall	I2C_Nak			; 
;	rjmp	CompareBufferSmall_NoErr
;CompareBufferNextByteSmall:
;	dec		cntL
;	brne	CompareBufferNextSmall		;  Z  ,    
;CompareBufferSmall_NoErr:
;	clc

	ldi		temp0, 0
	rcall	SendChar
	rcall	SendChar

WriteBufferSmall_Err:
	rcall	I2C_Stop
	ret						;
;-----------------------------------------------------------------
;-----------------------------------------------------------------
