;-----------------------------------------------------------------
At27ReadPage:
	ldi		temp0, 0
	out		DDRA, temp0		;  
	ldi		temp0, 0xFF
	out		PORTA, temp0		;  
	ldi		ADDR_LOW, 0
	rcall	Del_1ms
	cbi		PORTD, CE
RPNext:		;,  
	out		PORTB, ADDR_HI	;  
	out		PORTC, ADDR_LOW	;  
	rcall	Del_10t
	in		temp0, PINA		; 
	rcall	SendChar		;   .
	cpi		ADDR_LOW, 0xFF
	breq	RPEnd
	inc		ADDR_LOW		; 
	rjmp	RPNext
RPEnd:
	ret
;-----------------------------------------------------------------
At27IsClear:
	mov		XH, ADDR_HI		;   XH:XL   .
	mov		XL, ADDR_LOW
	clr		YH
	clr		YL
	ldi		temp0, 0
	out		DDRA, temp0		;  
	ldi		temp0, 0xFF
	out		PORTA, temp0		;  
	rcall	Del_1ms
	cbi		PORTD, CE
ICNext27:		;,  
	out		PORTB, YH	;  
	out		PORTC, YL	;  
	rcall	Del_10t
	in		temp0, PINA		; 
	cpi		temp0, 0xFF
	brne	NotClear27
	adiw	YH:YL, 1		; 
	sbiw	XH:XL, 1
	brne	ICNext27
	ldi		temp2, 0x43
ICEnd27:
	mov		VAL, temp0
	mov		temp0, temp2 
	rcall	SendChar
	mov		temp0, YH
	rcall	SendChar
	mov		temp0, YL
	rcall	SendChar
	mov		temp0, VAL
	rcall	SendChar
	ret						;
NotClear27:
	ldi		temp2, 0x44
	rjmp	ICEnd27
;-----------------------------------------------------------------

At27GetCS:
	clr		CS1			;  
	clr		CS2
	clr		CS3
	mov		XH, ADDR_HI		;   XH:XL   .
	mov		XL, ADDR_LOW
	clr		YH
	clr		YL
	ldi		temp0, 0
	out		DDRA, temp0		;  
	ldi		temp0, 0xFF
	out		PORTA, temp0		;  
	rcall	Del_1ms
	cbi		PORTD, CE
CSNext27:		;,  
	out		PORTB, YH	;  
	out		PORTC, YL	;  
	rcall	Del_10t
	in		temp0, PINA		; 

	clc		;c Carry	; 
	add		CS1, temp0
	clr		temp0
	adc		CS2, temp0
	adc		CS3, temp0
	clc						; 

	adiw	YH:YL, 1		; 
	sbiw	XH:XL, 1
	brne	CSNext27

	mov		temp0, CMD
	rcall	SendChar
	ldi		temp0, 0
	rcall	SendChar
	mov		temp0, CS1
	rcall	SendChar
	mov		temp0, CS2
	rcall	SendChar
	mov		temp0, CS3
	rcall	SendChar
	mov		temp0, ADDR_HI
	rcall	SendChar
	mov		temp0, ADDR_LOW
	rcall	SendChar

	ret						;

;-----------------------------------------------------------------
At27WriteBuffer:
	sbi		PORTD, OE
	cbi		PORTD, NOE

	sbi		PORTD, CE
	rcall	Del_1ms
	ldi		XL, low(BufferBegin)
	ldi		XH, high(BufferBegin)
	mov		YH, ADDR_HI
	mov		YL, ADDR_LOW
	ldi		cntL, 32
	ldi		cntH, 3
WBNext:
	ld		temp0, X+
	mov		VAL, temp0
WBTryWrite:
	ldi		ADR, 0xFF
	out		DDRA, ADR		;  
	out		PORTB, YH		;  
	out		PORTC, YL		;  
	out		PORTA, temp0	; 
	rcall	Del_10t
	cbi		PORTD, OE		; +12
	sbi		PORTD, NOE		; +12

	rcall	Del_10t
	rcall	Del_10t
	cbi		PORTD, CE		;
	rcall	Del_100mks		;  100
	sbi		PORTD, CE		;
	rcall	Del_10t
	rcall	Del_10t
	sbi		PORTD, OE		; +12
	cbi		PORTD, NOE		; +12

	rcall	Del_10t
	ldi		temp0, 0
	out		DDRA, temp0		;  
	ldi		temp0, 0xFF
	out		PORTA, temp0		;  
	cbi		PORTD, CE

	rcall	Del_10t
	in		temp0, PINA		; 
	sbi		PORTD, CE
	cp		temp0, VAL
;	brne	WBTry
	adiw	YH:YL, 1		; 
	dec		cntL			;    
	brne	WBNext			;  Z  ,    
	ldi		temp0, 0
WBErr:
	rcall	SendChar
	rcall	SendChar
	ret
WBTry:
	mov		temp0, VAL
	dec		cntH
	breq	WBTryWrite
	ldi		temp0, 0x77
	rjmp	WBErr
;-----------------------------------------------------------------
