.include "8515def.inc"
;GreyThing(AVR-based CTSM-K) firmware
;v. 0.1 

;PortA
.equ	iDir	= DDRA
.equ	iOut	= PORTA
.equ	iIn		= PINA

.equ	aA0			=0
.equ	aA1			=1
.equ	aA2			=2
.equ	SDA			=3
.equ	SCL			=4
.equ	WP			=5



;PortD
.equ	LED			=5




.equ	StackBegin		=RAMEND					; 
.equ	InitBaudRate	=3				; 7372800/16/115200-1	;UART on 115200

;   

;  
.equ	CMD_SENDID					=0x69
.equ	CMD_POWER					=0x50
.equ	POW_24						=0x0
.equ	POW_27						=0x1

.equ	CMD_AT24READPAGEBIG			=0xD0
.equ	CMD_AT24READPAGESMALL		=0xD1
.equ	CMD_AT24WRITEBUFFERBIG		=0xDF
.equ	CMD_AT24WRITEBUFFERSMALL	=0xDC
.equ	CMD_AT24GETCSBIG			=0xE0
.equ	CMD_AT24GETCSSMALL			=0xE1
.equ	CMD_AT24ISCLEARBIG			=0xE2
.equ	CMD_AT24ISCLEARSMALL		=0xE3
.equ	CMD_AT27READPAGE			=0x70
.equ	CMD_AT27WRITEBUFFER512		=0x7E
.equ	CMD_AT27WRITEBUFFER010		=0x7F


;
;.def	CS1			=R0		;
;.def	CS2			=R1		;temporary register
;.def	CS3			=R2		;temporary register
.def	CS1			=R3		;temporary register
.def	CS2			=R4		;temporary register
.def	CS3			=R5		;temporary register

.def	temp3			=R6		;
.def	temp4			=R7		;
;.def	8			=R8		;
;.def	9			=R9		;
;.def	10			=R10	;
;.def	11			=R11	;
;.def	12			=R12	;
;.def	13			=R13	;
;.def	14			=R14	;
.def	TmpSREG			=R15


.def	temp0		=R16		;temporary register
.def	temp1		=R17		;temporary register
.def	temp2		=R18		;temporary register
.def	cntL		=R19		;temporary register
.def	cntH		=R20		;temporary register


;CMD ADDR_HI ADDR_LOW VAL RSV ADR SUMM
.def	ADR			=R21		;  .
.def	CMD			=R22		;
.def	VAL			=R23		;  /
.def	ADDR_LOW	=R24		;,  
.def	ADDR_HI		=R25		;,  
;r26	XH
;r27	XL
;r28	YH
;r29	YL
;r30	ZH
;r31	ZL

.macro  jmpeq
	cpi		@0, @1
	brne	PC+2
	rjmp	@2
.endmacro

 	.dseg
	.org	0x60
BufferBegin:		.byte	64

;------------------------------------------------------------------------------------------
;********************************************************************
;* Interrupt table	;ENG;* Interrupt table
;********************************************************************
.cseg
;------------------------------------------------------------------------------------------
.org 0						;reset
	rjmp	Reset
;------------------------------------------------------------------------------------------
Reset:		
	; , 
	ldi		temp0, HIGH(StackBegin)	;    
	out		SPH, temp0
	ldi		temp0, LOW(StackBegin)
	out		SPL, temp0
	rcall	PortInit
;---------------------------------------------------------------
;Main program
Main:
	rcall	GetChar
	mov		CMD, temp0
	rcall	GetChar
	mov		ADDR_HI, temp0
	rcall	GetChar
	mov		ADDR_LOW, temp0
	rcall	GetChar
	mov		VAL, temp0
	rcall	GetChar
	mov		ADR, temp0


	;,    

	jmpeq	CMD, CMD_AT24READPAGEBIG, DoAT24ReadPage
	jmpeq	CMD, CMD_AT24READPAGESMALL, DoAT24ReadPageSmall
	jmpeq	CMD, CMD_AT24WRITEBUFFERSMALL, DoAt24WriteBufferSmall
	jmpeq	CMD, CMD_AT24WRITEBUFFERBIG, DoAT24WriteBuffer
	jmpeq	CMD, CMD_AT24GETCSBIG, DoAT24GetCSBig
	jmpeq	CMD, CMD_AT24ISCLEARBIG, DoAT24IsClearBig
	jmpeq	CMD, CMD_AT24GETCSSMALL, DoAT24GetCSSmall
	jmpeq	CMD, CMD_AT24ISCLEARSMALL, DoAT24IsClearSmall
	jmpeq	CMD, CMD_SENDID, SendDeviceID
	jmpeq	CMD, CMD_POWER, Power
	jmpeq	CMD, CMD_AT27READPAGE, DoAT27ReadPage
	jmpeq	CMD, CMD_AT27WRITEBUFFER512, DoAt27WriteBuffer512
	rjmp	UnknownCommand


;-----------------------------------------------------------------
PortInit:
	;  PORTA=0, PORTB,PORTC,PORTD=255
	ldi		temp0,0xFF
	out		DDRA, temp0		;  
	out		DDRB, temp0		;  
	out		DDRC, temp0		;C  
	out		DDRD, temp0		;D  
	ldi		temp0,0x0
	out		PORTA, temp0	; .   
	out		PORTC, temp0	; .   
	ldi		temp0, 0b01010111
	out		PORTB, temp0	; .  ,  ..

	ldi		temp0, 0b00001111
	out		PORTD, temp0
	
	;   
	ldi		temp0,0b00011000	;  , 8 
	out		UCR,temp0
	ldi		temp0, InitBaudRate
	out		UBRR,temp0		;   (115200 )
	ret
;--------------------------------------------------------------------------
Power:
	cpi		VAL, 1
	breq	POW_ON	
;	cpi		VAL, 0
;	breq	POW_OFF
;	rjmp	PWN

POW_OFF:
	cpi		ADDR_HI, POW_24
	brne	PWO1
	rcall	PowerOff24cXXX
	rjmp	PWN
PWO1:
	cpi		ADDR_HI, POW_27
	brne	PWN
	rcall	PowerOff27
	rjmp	PWN

POW_ON:
	cpi		ADDR_HI, POW_24
	brne	PW1
	rcall	PowerOn24cXXX
	rjmp	PWN
PW1:
	cpi		ADDR_HI, POW_27
	brne	PWN
	rcall	PowerOn27
PWN:
	mov		temp0, CMD
	rcall	SendChar
	mov		temp0, VAL
	rcall	SendChar
	rcall	SendChar
	rcall	SendChar

	rjmp	Main
;--------------------------------------------------------------------------
DoAT24GetCSBig:
	cbi		iOut, LED
	rcall	At24GetCSBig
	brcs	DoErrR
	sbi		iOut, LED
	rjmp	Main
;--------------------------------------------------------------------------
DoAT24IsClearBig:
	cbi		iOut, LED
	rcall	At24IsClearBig
	brcs	DoErrR
	sbi		iOut, LED
	rjmp	Main
;--------------------------------------------------------------------------
DoAT24GetCSSmall:
	cbi		iOut, LED
	rcall	At24GetCSSmall
	brcs	DoErrR
	sbi		iOut, LED
	rjmp	Main
;--------------------------------------------------------------------------
DoAT24IsClearSmall:
	cbi		iOut, LED
	rcall	At24IsClearSmall
	brcs	DoErrR
	sbi		iOut, LED
	rjmp	Main
;--------------------------------------------------------------------------
DoAT24ReadPage:
	cbi		PORTD, LED
	rcall	At24ReadPage
	brcs	DoErrR
	sbi		PORTD, LED
	rjmp	Main
;--------------------------------------------------------------------------
DoAT27ReadPage:
	cbi		PORTD, LED
	rcall	At27ReadPage
	sbi		PORTD, LED
	rjmp	Main
;--------------------------------------------------------------------------
DoAT27WriteBuffer512:
	cbi		PORTD, LED
	rcall	At27WriteBuffer512
	sbi		PORTD, LED
	rjmp	Main
;--------------------------------------------------------------------------
DoAT24ReadPageSmall:
	cbi		PORTD, LED
	rcall	At24ReadPageSmall
	brcs	DoErrR
	sbi		PORTD, LED
	rjmp	Main
;--------------------------------------------------------------------------
; cntL  
LoadInBuffer:
	ldi		XL, low(BufferBegin)
	ldi		XH, high(BufferBegin)
GetNextByte:
	rcall	GetChar
	st		X+, temp0	;
	dec		cntL
	brne	GetNextByte
	ret
;--------------------------------------------------------------------------
DoAT24WriteBuffer:
	cbi		iOut, LED
	ldi		cntL, 64
	rcall	LoadInBuffer
	rcall	At24WriteBuffer
	brcs	DoErrW
	sbi		iOut, LED
	rjmp	Main
;-----------------------------------------------------------------
DoAt24WriteBufferSmall:				;   8 
	cbi		iOut, LED				; 
	ldi		cntL, 16
	rcall	LoadInBuffer
	rcall	At24WriteBufferSmall	; 
	brcs	DoErrW
	sbi		iOut, LED				; 
	rjmp	Main
;-----------------------------------------------------------------
;-----------------------------------------------------------------
DoErrR:
	sbi		iOut, LED
	rcall	Del_1ms
	cbi		iOut, LED
	rcall	Del_1ms
	sbi		iOut, LED
	rcall	Del_1ms
	cbi		iOut, LED
	rcall	Del_1ms
	sbi		iOut, LED
	rcall	Del_1ms
	cbi		iOut, LED
	rcall	Del_1ms
	sbi		iOut, LED
	rcall	Del_1ms
	cbi		iOut, LED
	rcall	Del_1ms
	sbi		iOut, LED
	rjmp	Reset
;-----------------------------------------------------------------
;--------------------------------------------------------------------------
DoErrW:
	rcall	Del_1s
	rcall	Del_1s
	cbi		iOut, LED
	rcall	Del_1s
	rcall	Del_1s
	sbi		iOut, LED
	rjmp	Reset
;--------------------------------------------------------------------------
;-----------------------------------------------------------------
Test_1ms:
	ldi		temp0, 0
	ldi		temp1, 255
	out		DDRA, temp0
test1:
	out		PORTA, temp0
	out		PORTA, temp1
	out		PORTA, temp0
	out		PORTA, temp1
	out		PORTA, temp0
	out		PORTA, temp1
	out		PORTA, temp0
	out		PORTA, temp1
	out		PORTA, temp0
	out		PORTA, temp1
	out		PORTA, temp0
	out		PORTA, temp1
	out		PORTA, temp0
	out		PORTA, temp1
	out		PORTA, temp0
	out		PORTA, temp1
	out		PORTA, temp0
	out		PORTA, temp1
	out		PORTA, temp0
	out		PORTA, temp1
	out		PORTA, temp0
	out		PORTA, temp1
	out		PORTA, temp0
	out		PORTA, temp1
	out		PORTA, temp0
	out		PORTA, temp1
	out		PORTA, temp0
	out		PORTA, temp1
	out		PORTA, temp0
	out		PORTA, temp1
	out		PORTA, temp0
	out		PORTA, temp1
	out		PORTA, temp0
	out		PORTA, temp1
	out		PORTA, temp0
	out		PORTA, temp1
	out		PORTA, temp0
	out		PORTA, temp1
	out		PORTA, temp0
	out		PORTA, temp1
	out		PORTA, temp0
	out		PORTA, temp1
	out		PORTA, temp0
	out		PORTA, temp1
	out		PORTA, temp0
	out		PORTA, temp1
	out		PORTA, temp0
	out		PORTA, temp1
	out		PORTA, temp0
	out		PORTA, temp1
	out		PORTA, temp0
	out		PORTA, temp1
	rjmp 	test1
	ret
;-----------------------------------------------------------------
;-----------------------------------------------------------------
Del_1s:
	ldi		temp2, 0xFF
D2:	rcall	Del_1ms
	rcall	Del_1ms
	rcall	Del_1ms
	rcall	Del_1ms
	dec		temp2
	brne	D2
	ret
;-----------------------------------------------------------------
Del_1ms:	;  1  (246  4.05  7.3728MHz)
	ldi		temp1, 0xF6
D1:	rcall	Del_10t
	rcall	Del_10t
	rcall	Del_10t
	dec		temp1
	brne	D1
	ret
;-----------------------------------------------------------------
Del_100mks:	;  100 
	ldi		temp1, 0x3D
D3:	rcall	Del_10t
	dec		temp1
	brne	D3
	ret
;-----------------------------------------------------------------
Del_10t:	;  10  - 1.35  7.3728MHz
	nop
	nop
	nop
	ret
;-----------------------------------------------------------------
SendDeviceID:
	ldi		ZH, high(DeviceID<<1)		;   
	ldi		ZL, low(DeviceID<<1)
	ldi		temp1, 20
SendDeviceID_1:
	lpm
	mov		temp0, r0
	rcall	SendChar
	adiw	ZH:ZL,1
	dec		temp1
	brne	SendDeviceID_1
	rjmp	Main
;-----------------------------------------------------------------
UnknownCommand:
	rcall	PortInit
	mov		temp1, temp0
	mov		temp0, CMD
	rcall	SendChar
	ldi		temp0, 0x55
	rcall	SendChar
	ldi		temp0, 0x00
	rcall	SendChar
	rcall	SendChar
	rcall	SendChar
	mov		temp0, temp1
	rcall	SendChar
	rjmp	Main
;-----------------------------------------------------------------
SendChar:
	sbis	USR,UDRE		;    
	rjmp	SendChar
	out		UDR,temp0		;  
	ret
;-----------------------------------------------------------------                                                                 
GetChar:
	sbis	USR,RXC			;   

	rjmp	GetChar
	in		temp0,UDR		;  
	clc
	sbic	USR,FE			;  , 
	sec						;  C
	ret
;-----------------------------------------------------------------


;-----------------------------------------------------------------
DeviceID:
	.db		"Grey Thing AVR v.0.1"
			;01234567890123456789
DeviceIDEnd:
;-----------------------------------------------------------------





;CTSM-K Device firmware
;.0.10
;CSect - 0000h
;RSect - 0040h
;    -   ,  

	
;VAL:		.reg	r2
;CMD:		.reg	r3
;ADR:		.reg	r4
;CNT:		.reg	r5
;ADDR_HI:	.reg	r6
;ADDR_LOW:	.reg	r7

;buff:		.ds	32
;fs:		.ds	3
;sc:		.ds	3

;	.CODE
;	org	0h
;	ljmp	START

;	org	03h			; INT0
;	reti

;	org	0bh			; T0
;	reti

;	org	013h			; INT1
;	reti

;	org	01bh			; T1
;	reti

		;	org	40h
		;VER:	.dc	"CTSM-K v.0.10    "	;17 bytes
		;		;12345678901234560
;	.org	100h
;START:	orl     pcon, #10000000b        ;set double baud rate, clear all timer1 bits in tmod,
;	mov	tmod, #00100000b	;set timer1 as 8 bit auto reload
;	setb	PWR
;	setb	OE
;	setb	CE
;	mov	p0, #0
;	mov	p1, #0
;	mov	p2, #0

;INIT:
;	clr	ea  
;	clr	tr1                    
;	clr	tf1
;	mov	a, #255
;	mov	th1, a 
;	mov	tl1, a
;	mov	scon, #01010000b 
;	setb	tr1              
;	setb	ea  
             
;	setb	OE			;1111111111111111111111111111111111111111111111111111111111111111111111
;	setb	CE
;	mov	sp, #7

;	lcall	GET_CHAR
;	mov	CMD, a
;	lcall	GET_CHAR
;	mov	ADDR_HI, a
;	lcall	GET_CHAR
;	mov	ADDR_LOW, a
;	lcall	GET_CHAR
;	mov	VAL, a
;	lcall	GET_CHAR
;	mov	ADR, a

;	cjne	CMD, #57h, NEXT1
;	ljmp	S_WRITEBYTE
;NEXT1:	cjne	CMD, #53h, NEXT2
;	ljmp	S_READPAGE
;NEXT2:	cjne	CMD, #4Ch, NEXT3
;	ljmp	P_KS
;NEXT3:	cjne	CMD, #3Fh, NEXT4
;	ljmp	S_ISCLEAR
;NEXT4:	cjne	CMD, #01h, NEXT5
;	ljmp	S_WRITEBLOCK
;NEXT5:	cjne	CMD, #4Bh, NEXT6
;	ljmp	S_KS
;NEXT6:	cjne	CMD, #72h, NEXT7
;	ljmp	P_READPAGE
;NEXT7:	cjne	CMD, #73h, NEXT8
;	ljmp	P_READBYTE
;NEXT8:	cjne	CMD, #77h, NEXT9
;	ljmp	WRPAGE_P
;NEXT9:	cjne	CMD, #76h, NEXT10
;	ljmp	WRBYTE_P
;NEXT10:	cjne	CMD, #50h, NEXT11
;	ljmp	POWER
;NEXT11:	cjne	CMD, #2Fh, NEXT12
;	ljmp	P_ISCLEAR
		;NEXT12:	cjne	CMD, #69h, ENDCYC
		;	ljmp	ID
;ENDCYC:	ljmp	INIT

		;ID:	mov	dptr, #40h
		;	mov	CNT, #16
		;I1:	movc	a, @a+dtpr
		;	lcall	PUT_CHAR
		;	mov	a, #0
		;	inc	dptr
		;	djnz	CNT, I1
		;	ljmp	INIT

;POWER:	cjne	VAL, #1, POFF
;	clr	PWR
;	ljmp	P_ANSW
;POFF:	setb	PWR
;	mov	p0, #0
;	mov	p1, #0
;	mov	p2, #0
;	ljmp	P_ANSW
;P_ANSW:
;	mov	a, CMD
;	lcall	PUT_CHAR
;	jb	PWR, AOFF
;	mov	a, #0
;	lcall	PUT_CHAR
;	lcall	PUT_CHAR
;	lcall	PUT_CHAR
;	ljmp	INIT
;AOFF:	mov	a, #1
;	lcall	PUT_CHAR
;	lcall	PUT_CHAR
;	lcall	PUT_CHAR
;	ljmp	INIT

;P_READPAGE:
;	mov	p0, #0ffh
;	setb	OE			;11111111111111111111111111111111111111111111111111111111111111111111111111111111111111
;	clr	CE
;	nop
;	mov	ADDR_LOW, #0
;LP:	mov	p1, ADDR_HI
;	mov	p2, ADDR_LOW
;	mov	a, p0
;	lcall	PUT_CHAR
;	cjne	ADDR_LOW, #0FFh, INCB
;	setb	CE
;	ljmp	INIT
;INCB:	inc	ADDR_LOW
;	sjmp	LP

;P_READBYTE:
;	mov	p0, #0ffh
;	setb	OE			;111111111111111111111111111111111111111111111111111111111111111111111111111111111111
;	clr	CE
;	nop
;	mov	p1, ADDR_HI
;	mov	p2, ADDR_LOW
;	mov	a, p0
;	lcall	PUT_CHAR
;	setb	CE
;	ljmp	INIT

;S_KS:
; 
;	lcall	CLEARKS
;	lcall	I2C_START
;	jc	KSEXIT
;	mov	ADDR_HI, #0
;	mov	ADDR_LOW, #0
;	mov	a, ADR
;	lcall	I2C_OUT
;	jc	KSSTP
;	mov	a, ADDR_HI
;	lcall	I2C_OUT
;	jc	KSSTP
;	mov	a, ADDR_LOW
;	lcall	I2C_OUT
;	jc	KSSTP
;	lcall	I2C_START
;	jc	KSSTP
;	mov	a, ADR
;	orl	a, #00000001b
;	lcall	I2C_OUT
;	jc	KSSTP
;KS0:				; 
;	lcall	I2C_IN
;	lcall	KSADD
;	cjne	ADDR_LOW, #0FFh, KS1
;	cjne	ADDR_HI, #07Fh, KS2
;	ljmp	KSEND
;KS2:	mov	ADDR_LOW, #0
;	inc	ADDR_HI
;	ljmp	KSNEXT
;KS1:
;	inc	ADDR_LOW
;	ljmp	KSNEXT

;KSNEXT:	lcall	I2C_ACK
;	ljmp	KS0
;KSEND:	lcall	I2C_NAK
;	clr	c
;	lcall	KSSEND
;KSSTP:	lcall	I2C_STOP
;KSEXIT:	ljmp	INIT




;P_KS:
; 
;	lcall	CLEARKS
;	mov	p0, #0ffh
;	setb	OE			;1111111111111111111111111111111111111111111111111111111111111111111111111111111111
;	clr	CE
;	nop
;	mov	ADDR_LOW, #0
;	mov	ADDR_HI, #0
;KS64_0:	mov	p1, ADDR_HI
;	mov	p2, ADDR_LOW
;	mov	a, p0
;	lcall	KSADD
;	cjne	ADDR_LOW, #0FFh, KS64_1
;	cjne	ADDR_HI, #0FFh, KS64_2
;	ljmp	KS64END
;KS64_2:	mov	ADDR_LOW, #0
;	inc	ADDR_HI
;	ljmp	KS64_0
;KS64_1:	inc	ADDR_LOW
;	ljmp	KS64_0
;KS64END:
;	setb	CE
;	lcall	KSSEND
;	ljmp	INIT



;, /  ,  ,  43 00 00 00
; 44 Ah Al VL
;P_ISCLEAR:
; 
;	mov	p0, #0ffh
;	setb	OE			; +12
;	clr	CE			;  
;	nop
;	mov	ADDR_LOW, #0
;	mov	ADDR_HI, #0
;PI_0:	mov	p1, ADDR_HI
;	mov	p2, ADDR_LOW
;	mov	a, p0
;	cjne	a, #0ffh, PNC
;	cjne	ADDR_LOW, #0FFh, PI_1
;	cjne	ADDR_HI, #0FFh, PI_2
;	ljmp	PIEND
;PI_2:	mov	ADDR_LOW, #0
;	inc	ADDR_HI
;	ljmp	PI_0
;PI_1:	inc	ADDR_LOW
;	ljmp	PI_0
;PIEND:	setb	CE			;  
;	lcall	CHIP_CLEAR		; ,  . 
;	ljmp	INIT
;PNC:	setb	CE			;  
;	lcall	CHIP_NOT_CLEAR		; ,  . 
;	ljmp	INIT


;WRPAGE_P:
;	mov	CNT, #32
;	mov	r0, #buff
;WRPL0:	lcall	GET_CHAR
;	mov	@r0, a
;	inc	r0
;	djnz	CNT, WRPL0
;	mov	CNT, #32
;;	mov	p0, #255
;	mov	VAL, #3		; 
;	setb	CE
;	setb	OE			;1111111111111111111111111111111111111111111111111111111111111111111111111111111
;	mov	r0, #buff
;WRPL1:	mov	p1, ADDR_HI
;	mov	p2, ADDR_LOW
;	mov	a, @r0
;	mov	p0, a
;	clr	OE			;1111111111111111111111111111111111111111111111111111111111111111111111111111111111
;	clr	CE
;	lcall	NOPP
;	setb	CE
;	setb	OE			;111111111111111111111111111111111111111111111111111111111111111111111111111111111
;;	mov	p1, #0
;;	mov	p2, #0
;	clr	CE
;;	mov	p1, ADDR_HI
;;	mov	p2, ADDR_LOW
;	mov	a, p0
;	setb	CE
;	mov	b, a
;	subb	a, @r0
;	jnz	WRPREP
;	inc	r0
;	inc	ADDR_LOW
;	djnz	CNT, WRPL1
;	ljmp	WRPEND
;WRPREP:	
;	djnz	VAL, WRPL1
;	mov	a, #77h
;	lcall	PUT_CHAR
;	lcall	PUT_CHAR
;	ljmp	INIT
;WRPEND:	
;	mov	a, #0
;	lcall	PUT_CHAR
;	lcall	PUT_CHAR
;WRPEXIT:ljmp	INIT


;WRBYTE_P:
;	mov	CNT, #3		; 
;	setb	CE
;	setb	OE			;11111111111111111111111111111111111111111111111111111111111111111111111111111111
;	nop
;	nop
;	nop
;	nop
;WRBL1:	mov	p1, ADDR_HI
;	mov	p2, ADDR_LOW
;	mov	p0, VAL
;	clr	OE			;111111111111111111111111111111111111111111111111111111111111111111111111111111111
;	clr	CE
;	lcall	NOPP
;	setb	CE
;	setb	OE			;111111111111111111111111111111111111111111111111111111111111111111111111111111
;
;	clr	CE
;	mov	a, p0
;	setb	CE
;	
;	subb	a, VAL
;	jz	WRBREP
;	sjmp	WRBEND
;WRBREP:	djnz	VAL, WRBL1
;	mov	a, #77
;	lcall	PUT_CHAR
;	lcall	PUT_CHAR
;	ljmp	INIT
;WRBEND:
;	mov	a, #0
;	lcall	PUT_CHAR
;	lcall	PUT_CHAR
;WRBEXIT:ljmp	INIT



;S_WRITEBLOCK:
;	mov	CNT, #32
;	mov	r0, #buff
;WPL0:	lcall	GET_CHAR
;	mov	@r0, a
;	inc	r0
;	djnz	CNT, WPL0
;	lcall	I2C_START
;	jc	WPEXIT
;	mov	a, ADR
;	lcall	I2C_OUT
;	jc	WPSTP
;	mov	a, ADDR_HI
;	lcall	I2C_OUT
;	jc	WPSTP
;	mov	a, ADDR_LOW
;	lcall	I2C_OUT
;	jc	WPSTP
;	mov	CNT, #32
;	mov	r0, #buff
;WPL1:	mov	a, @r0
;	lcall	I2C_OUT
;	jc	WPSTP
;	inc	r0
;	nop
;	nop
;	nop
;	djnz	CNT, WPL1
;	clr	c
;	mov	a, #0
;	lcall	PUT_CHAR
;	lcall	PUT_CHAR
;WPSTP:	lcall	I2C_STOP
;WPEXIT:	ljmp	INIT


;S_WRITEBYTE:
;	lcall	I2C_START
;	jc	WEXIT
;	mov	a, ADR
;	lcall	I2C_OUT
;	jc	WSTP
;	mov	a, ADDR_HI
;	lcall	I2C_OUT
;	jc	WSTP
;	mov	a, ADDR_LOW
;	lcall	I2C_OUT
;	jc	WSTP
;	mov	a, VAL		;byte
;	lcall	I2C_OUT
;	jc	WSTP
;	clr	c
;WSTP:
;	lcall	I2C_STOP
;WEXIT:
;	mov	VAL, #1
;	ljmp	INIT

;S_READPAGE:
;	mov	CNT, #0FFh
;	lcall	I2C_START
;	jc	PEXIT
;	mov	a, ADR
;	lcall	I2C_OUT
;	jc	PSTP
;	mov	a, VAL
;	lcall	I2C_OUT
;	jc	PSTP
;	mov	a, #0
;	lcall	I2C_OUT
;	jc	PSTP
;	lcall	I2C_START
;	jc	PSTP
;	mov	a, ADR
;	orl	a, #00000001b
;	lcall	I2C_OUT
;	jc	PSTP
;	lcall	I2C_IN
;	lcall	PUT_CHAR
;PLAB1:
;	lcall	I2C_ACK
;	lcall	I2C_IN
;	lcall	PUT_CHAR
;	cjne	CNT, #1, PLAB2
;	lcall	I2C_NAK
;	ljmp	PLAB3
;PLAB2:
;	djnz	CNT, PLAB1
;PLAB3:
;	clr	c
;PSTP:
;	lcall	I2C_STOP
;PEXIT:
;	ljmp	INIT


;, /  ,  ,  43 00 00 00
; 44 Ah Al VL
;S_ISCLEAR:
;	lcall	I2C_START
;	jc	ICEXIT
;	mov	ADDR_HI, #0
;	mov	ADDR_LOW, #0
;	mov	a, ADR
;	lcall	I2C_OUT
;	jc	ICSTP
;	mov	a, ADDR_HI
;	lcall	I2C_OUT
;	jc	ICSTP
;	mov	a, ADDR_LOW
;	lcall	I2C_OUT
;	jc	ICSTP
;	lcall	I2C_START
;	jc	ICSTP
;	mov	a, ADR
;	orl	a, #00000001b
;	lcall	I2C_OUT
;	jc	ICSTP
;L0:
;	lcall	I2C_IN
;	cjne	a, #0FFh, NOT_CLEAR
;	cjne	ADDR_LOW, #0FFh, L1
;	cjne	ADDR_HI, #07Fh, L2
;	ljmp	ICEND
;L2:	mov	ADDR_LOW, #0
;	inc	ADDR_HI
;	ljmp	ICNEXT
;L1:
;	inc	ADDR_LOW
;	ljmp	ICNEXT

;ICNEXT:	lcall	I2C_ACK
;	ljmp	L0
;ICEND:	
;	lcall	I2C_NAK
;	clr	c
;	lcall	CHIP_CLEAR
;ICSTP:
;	lcall	I2C_STOP
;ICEXIT:
;	ljmp	INIT

;NOT_CLEAR:
;	lcall	CHIP_NOT_CLEAR
;	lcall	I2C_NAK
;	clr	c
;	ljmp	ICSTP

;CHIP_CLEAR:
;	mov	a, #43h
;	lcall	PUT_CHAR
;	mov	a, #0
;	lcall	PUT_CHAR
;	lcall	PUT_CHAR
;	lcall	PUT_CHAR
;	ret

;CHIP_NOT_CLEAR:
;	mov	VAL, a
;	mov	a, #44h
;	lcall	PUT_CHAR
;	mov	a, ADDR_HI
;	lcall	PUT_CHAR
;	mov	a, ADDR_LOW
;	lcall	PUT_CHAR
;	mov	a, VAL
;	lcall	PUT_CHAR
;	ret

.include "At24.asm"
.include "At27.asm"
