// SRWDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SRW.h"
#include "SRWDlg.h"
//#include "commdlg.h"
//#include "cderr.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

LPSTR lpDevName = "COM1";
LPSTR lpProjName = "Serial Read/Write";
LPSTR lpLog = "SRW.log";
int lpSize = 32768;
long lpSpeed = 115200;
int NumRec = 0;

byte DAT[65536];
bool Loaded = false;
bool Edited = false;

/////////////////////////////////////////////////////////////////////////////
// CSRWDlg dialog

CSRWDlg::CSRWDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSRWDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSRWDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSRWDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSRWDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSRWDlg, CDialog)
	//{{AFX_MSG_MAP(CSRWDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_CBN_SELCHANGE(IDC_PORTNUM, OnSelchangePortnum)
	ON_BN_CLICKED(IDC_READALL, OnReadall)
	ON_BN_CLICKED(IDC_CLEARALL, OnClearall)
	ON_BN_CLICKED(IDC_ISCLEAR, OnIsclear)
	ON_BN_CLICKED(IDC_CHECKSUM, OnChecksum)
	ON_BN_CLICKED(IDC_LOADBUFFER, OnLoadbuffer)
	ON_CBN_SELCHANGE(IDC_FSIZE, OnSelchangeSize)
	ON_LBN_DBLCLK(IDC_DAT, OnDblclkDat)
	ON_BN_CLICKED(IDC_SAVESTR, OnSavestr)
	ON_BN_CLICKED(IDC_SAVEBUFFER, OnSavebuffer)
	ON_BN_CLICKED(IDC_WRITEBUFF, OnWritebuff)
	ON_BN_CLICKED(IDC_CLEARBUFF, OnClearbuff)
	ON_LBN_DBLCLK(IDC_LISTDEV, OnDblclkListdev)
	ON_BN_CLICKED(IDC_CLEARSTR, OnClearstr)
	ON_BN_CLICKED(IDC_COMPARE, OnCompare)
	ON_BN_CLICKED(IDC_CLEARRGN, OnClearrgn)
	ON_EN_KILLFOCUS(IDC_FROM, OnKillfocusFrom)
	ON_EN_KILLFOCUS(IDC_TO, OnKillfocusTo)
	ON_LBN_SELCHANGE(IDC_DAT, OnSelchangeDat)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSRWDlg message handlers

BOOL CSRWDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	IFSet(this->m_hWnd);
	ReadConfig(this->m_hWnd);
	return TRUE;  // return TRUE  unless you set the focus to a control


}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSRWDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}


// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSRWDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CSRWDlg::OnSelchangePortnum() 
{
	long lRes;
	lRes = SendDlgItemMessage(IDC_PORTNUM, CB_GETCURSEL, 0, 0);
	if (lRes != CB_ERR)
	{
		if (lRes==0)
			lpDevName = "COM1";
		else if (lRes==1)
			lpDevName = "COM2";
		else if (lRes==2)
			lpDevName = "COM3";
		else if (lRes==3)
			lpDevName = "COM4";
	}
	else

	MessageBox("Error GetCurSel", lpProjName, MB_OK);
	LPCTSTR lpszEntry = "PortNum";
	LPCTSTR lpszSectionName = "Main";
	CString StrTmp = lpDevName;
	int Res=0;
	Res = IniRW_Text(true,lpszSectionName,lpszEntry, StrTmp);

}

void CSRWDlg::OnReadall() 
{
	long lRes;
	lRes = SendDlgItemMessage(IDC_FSIZE, CB_GETCURSEL, 0, 0);
	if (lRes != CB_ERR)
	{
		if ((lRes >=0) && (lRes <4))
			srwReadAllSmall();
		else if ((lRes >=4) && (lRes <9))
			srwReadAll();
		else if ((lRes >=9) && (lRes <10))
			prwReadAll();
		else
				MessageBox(" GetCurSel", lpProjName, MB_OK);
	}
	else
		MessageBox(" GetCurSel", lpProjName, MB_OK);

	SaveBuffer();
	FillBuff(this->m_hWnd);
}

void CSRWDlg::OnClearall() 
{
	long lRes;
	lRes = SendDlgItemMessage(IDC_FSIZE, CB_GETCURSEL, 0, 0);
	if (lRes != CB_ERR)
	{
		if ((lRes >=0) && (lRes <4))
			srwWriteBufferSmall(255);
		else if ((lRes >=4) && (lRes <9))
			srwWriteBuffer(255);
		else if ((lRes >=9) && (lRes <10))
			MessageBox("   .  ", lpProjName, MB_OK);
		else
			MessageBox(" GetCurSel - CLEARALL", lpProjName, MB_OK);
	}
	else
		MessageBox(" GetCurSel - CLEARALL", lpProjName, MB_OK);




	
}

void CSRWDlg::OnIsclear() 
{
	long lRes;
	lRes = SendDlgItemMessage(IDC_FSIZE, CB_GETCURSEL, 0, 0);
	if (lRes != CB_ERR)
	{
		if ((lRes >=0) && (lRes <4))
			srwIsClear(0x3E);
		else if ((lRes >=4) && (lRes <9))
			srwIsClear(0x3F);
		else if ((lRes >=9) && (lRes <10))
			srwIsClear(0x2F);
		else
				MessageBox("Error GetCurSel", lpProjName, MB_OK);
	}
	else
		MessageBox("Error GetCurSel", lpProjName, MB_OK);
}

void CSRWDlg::OnChecksum() 
{
	long lRes;
	lRes = SendDlgItemMessage(IDC_FSIZE, CB_GETCURSEL, 0, 0);
	if (lRes != CB_ERR)
	{
		if ((lRes >=0) && (lRes <4))
			srwCheckCS(0x4A);
		else if ((lRes >=4) && (lRes <9))
			srwCheckCS(0x4B);
		else if ((lRes >=9) && (lRes <10))
			srwCheckCS(0x4C);
		else
				MessageBox("Error GetCurSel", lpProjName, MB_OK);
	}
	else
		MessageBox("Error GetCurSel", lpProjName, MB_OK);
}



void CSRWDlg::OnLoadbuffer() 
{
	LoadToBuffer();
	FillBuff(this->m_hWnd);
}

void CSRWDlg::OnSelchangeSize() 
{
	long lRes;
	lRes = SendDlgItemMessage(IDC_FSIZE, CB_GETCURSEL, 0, 0);
	if (lRes != CB_ERR)
	{
		if (lRes == 0)
				lpSize = 256;
		else if (lRes == 1)
				lpSize = 512;
		else if (lRes == 2)
				lpSize = 1024;
		else if (lRes == 3)
				lpSize = 2048;
		else if (lRes == 4)
				lpSize = 4096;
		else if (lRes == 5)
				lpSize = 8192;
		else if (lRes == 6)
				lpSize = 16384;
		else if (lRes == 7)
				lpSize = 32768;
		else if (lRes == 8)
				lpSize = 65536;
		else if (lRes == 9)
				lpSize = 65536;
		else
				MessageBox("Error GetCurSel", lpProjName, MB_OK);
	}
	else
		MessageBox("Error GetCurSel", lpProjName, MB_OK);

	LPCTSTR lpszEntry = "Size";
	LPCTSTR lpszSectionName = "Main";
	DWORD DWordTmp = lpSize;
	int Res=0;
	Res = IniRW_DWord(true,lpszSectionName,lpszEntry, DWordTmp);
	lpszEntry = "Chip";
	DWordTmp = lRes;
	Res = IniRW_DWord(true,lpszSectionName,lpszEntry, DWordTmp);

//	Res=SendDlgItemMessage(IDC_CLEARALL, WM_ENABLE, (WPARAM) false, NULL);
	

	SetClearRgn(0, lpSize-1, this->m_hWnd);
	memset(&DAT,0xFF, 65536);
	FillBuff(this->m_hWnd);
}

void CSRWDlg::OnDblclkDat() 
{
	int i=0, j=0;
	char szBuff[54];
	char szStr[47];
	NumRec = SendDlgItemMessage(IDC_DAT, LB_GETCURSEL, 0, 0);
	SendDlgItemMessage(IDC_DAT, LB_GETTEXT, NumRec, (LPARAM) &szBuff);
	for (i=6, j=0; i<54;szStr[j]=szBuff[i], i++, j++) {};
	SetDlgItemText(IDC_EDSTR, szStr);
}


void CSRWDlg::OnSavestr() 
{
	char sStr[47];
	byte bStr[16];
	byte b=0, c=0;
	int z=0, i=0, j=0;
	char txt[54] = "Addr: 00 01 02 03 04 05 06 07 08 09 0A 0B 0C 0D 0E 0F";
	int adr;
	byte adr_h, adr_l;

	GetDlgItemText(IDC_EDSTR, sStr, 48);
	z = strlen(sStr);
	if (z != 47)
	{
		MessageBox(_T(" .    ,  ...   16 ."), lpProjName, MB_OK);
		goto Ex;
	}
	//  
	for (i=0, j=0;i<z-1;)
	{
L0:;
		if (i==2 || i==5 || i==8 || i==11 || i== 14 || i==17 || i==20 ||  i==23 ||  i==26 ||  i==29 ||  i==32 ||  i==35 ||  i==38 ||   i==41 ||   i==44)
		{
			i++;
			j++;
			goto L0;
		}
		b=ValHex(sStr[i]);
		if (b == 0xff)
		{
			TCHAR	tszMsg[50];
			_sntprintf(tszMsg, 50, _T(" .  %d  !"), i);
			MessageBox(tszMsg, lpProjName, MB_OK);
			goto Ex;
		}
		bStr[j] = b<<4;
		i++;
		b=ValHex(sStr[i]);
		if (b == 0xff)
		{
			TCHAR	tszMsg[50];
			_sntprintf(tszMsg, 50, _T(" .  %d  !"), i);
			MessageBox(tszMsg, lpProjName, MB_OK);
			goto Ex;
		}
		bStr[j] += b;
		i++;
	}
	// 

	for (i=0, adr = NumRec * 16;i<16; DAT[adr]=bStr[i], i++, adr++) {};
	adr = NumRec * 16;
	adr_h = adr / 256;
	adr_l = adr % 256;
	txt[0] = dhex(adr_h / 16);
	txt[1] = dhex(adr_h % 16);
	txt[2] = dhex(adr_l / 16);
	txt[3] = dhex(adr_l % 16);
	txt[4] = 0x3a;
	txt[5] = 0x20;
	txt[6] = dhex(DAT[adr] / 16);
	txt[7] = dhex(DAT[adr] % 16);
	txt[8] = 0x20;
	txt[9] = dhex(DAT[adr + 1] / 16);
	txt[10] = dhex(DAT[adr + 1] % 16);
	txt[11] = 0x20;
	txt[12] = dhex(DAT[adr + 2] / 16);
	txt[13] = dhex(DAT[adr + 2] % 16);
	txt[14] = 0x20;
	txt[15] = dhex(DAT[adr + 3] / 16);
	txt[16] = dhex(DAT[adr + 3] % 16);
	txt[17] = 0x20;
	txt[18] = dhex(DAT[adr + 4] / 16);
	txt[19] = dhex(DAT[adr + 4] % 16);
	txt[20] = 0x20;
	txt[21] = dhex(DAT[adr + 5] / 16);
	txt[22] = dhex(DAT[adr + 5] % 16);
	txt[23] = 0x20;
	txt[24] = dhex(DAT[adr + 6] / 16);
	txt[25] = dhex(DAT[adr + 6] % 16);
	txt[26] = 0x20;
	txt[27] = dhex(DAT[adr + 7] / 16);
	txt[28] = dhex(DAT[adr + 7] % 16);
	txt[29] = 0x20;
	txt[30] = dhex(DAT[adr + 8] / 16);
	txt[31] = dhex(DAT[adr + 8] % 16);
	txt[32] = 0x20;
	txt[33] = dhex(DAT[adr + 9] / 16);
	txt[34] = dhex(DAT[adr + 9] % 16);
	txt[35] = 0x20;
	txt[36] = dhex(DAT[adr + 10] / 16);
	txt[37] = dhex(DAT[adr + 10] % 16);
	txt[38] = 0x20;
	txt[39] = dhex(DAT[adr + 11] / 16);
	txt[40] = dhex(DAT[adr + 11] % 16);
	txt[41] = 0x20;
	txt[42] = dhex(DAT[adr + 12] / 16);
	txt[43] = dhex(DAT[adr + 12] % 16);
	txt[44] = 0x20;
	txt[45] = dhex(DAT[adr + 13] / 16);
	txt[46] = dhex(DAT[adr + 13] % 16);
	txt[47] = 0x20;
	txt[48] = dhex(DAT[adr + 14] / 16);
	txt[49] = dhex(DAT[adr + 14] % 16);
	txt[50] = 0x20;
	txt[51] = dhex(DAT[adr + 15] / 16);
	txt[52] = dhex(DAT[adr + 15] % 16);
	txt[53] = 0x00;
	SendDlgItemMessage(IDC_DAT, LB_DELETESTRING, (WPARAM) NumRec, 0);
	SendDlgItemMessage(IDC_DAT, LB_INSERTSTRING, (WPARAM) NumRec, (LPARAM) &txt);
	SetDlgItemText(IDC_EDSTR, _T(""));
	Edited = true;
Ex:;
   RefreshCS();
}

void CSRWDlg::OnSavebuffer() 
{
	SaveBuffer();
}

void CSRWDlg::OnWritebuff() 
{
	long lRes;
	lRes = SendDlgItemMessage(IDC_FSIZE, CB_GETCURSEL, 0, 0);
	if (lRes != CB_ERR)
	{
		if ((lRes >=0) && (lRes <4))
			srwWriteBufferSmall(0);
		else if ((lRes >=4) && (lRes <9))
			srwWriteBuffer(0);
		else if ((lRes >=9) && (lRes <10))
			prwWriteBuffer();
		else
			MessageBox("Error GetCurSel", lpProjName, MB_OK);
	}
	else
		MessageBox("Error GetCurSel", lpProjName, MB_OK);
}



void CSRWDlg::OnClearbuff() 
{
	if (MessageBox("  ?", lpProjName, MB_YESNO) == IDYES)
	{
		memset(&DAT, 0xff, 65536);
		FillBuff(this->m_hWnd);	
		SetClearRgn(0, lpSize-1, this->m_hWnd);
	}	
}


void CSRWDlg::OnDblclkListdev() 
{
	int i=0;
	i = SendDlgItemMessage(IDC_LISTDEV, LB_GETCURSEL, 0, 0);

    switch (i)
    {
    case 0:
		CheckDlgButton(IDC_A0, 1);
		CheckDlgButton(IDC_A1, 0);
		SendDlgItemMessage(IDC_FSIZE, CB_SETCURSEL, (WPARAM) 7, 0);
		lpSize=32768;
        break;

    case 1:
		CheckDlgButton(IDC_A0, 0);
		CheckDlgButton(IDC_A1, 1);
		SendDlgItemMessage(IDC_FSIZE, CB_SETCURSEL, (WPARAM) 5, 0);
		lpSize=8192;
        break;

    case 2:
		CheckDlgButton(IDC_A0, 1);
		CheckDlgButton(IDC_A1, 1);
		SendDlgItemMessage(IDC_FSIZE, CB_SETCURSEL, (WPARAM) 7, 0);
		lpSize=32768;
        break;

    case 3:
		CheckDlgButton(IDC_A0, 0);
		CheckDlgButton(IDC_A1, 0);
		SendDlgItemMessage(IDC_FSIZE, CB_SETCURSEL, (WPARAM) 7, 0);
		lpSize=32768;
        break;

    case 4:
		CheckDlgButton(IDC_A0, 0);
		CheckDlgButton(IDC_A1, 1);
		SendDlgItemMessage(IDC_FSIZE, CB_SETCURSEL, (WPARAM) 7, 0);
		lpSize=32768;
        break;

    case 5:
		CheckDlgButton(IDC_A0, 1);
		CheckDlgButton(IDC_A1, 0);
		SendDlgItemMessage(IDC_FSIZE, CB_SETCURSEL, (WPARAM) 7, 0);
		lpSize=32768;
        break;

	}
	SetClearRgn(0, lpSize-1, this->m_hWnd);
}

void CSRWDlg::OnClearstr() 
{
	int i=0, Num=0, adr=0;
	char txt[54];
	Num = SendDlgItemMessage(IDC_DAT, LB_GETCURSEL, 0, 0);
	SendDlgItemMessage(IDC_DAT, LB_GETTEXT, Num, (LPARAM) &txt);
	for (i=0, adr = Num * 16;i<16; DAT[adr]=0x0ff, i++, adr++) {};
	txt[6] = 0x46;
	txt[7] = 0x46;
	txt[9] = 0x46;
	txt[10] = 0x46;
	txt[12] = 0x46;
	txt[13] = 0x46;
	txt[15] = 0x46;
	txt[16] = 0x46;
	txt[18] = 0x46;
	txt[19] = 0x46;
	txt[21] = 0x46;
	txt[22] = 0x46;
	txt[24] = 0x46;
	txt[25] = 0x46;
	txt[27] = 0x46;
	txt[28] = 0x46;
	txt[30] = 0x46;
	txt[31] = 0x46;
	txt[33] = 0x46;
	txt[34] = 0x46;
	txt[36] = 0x46;
	txt[37] = 0x46;
	txt[39] = 0x46;
	txt[40] = 0x46;
	txt[42] = 0x46;
	txt[43] = 0x46;
	txt[45] = 0x46;
	txt[46] = 0x46;
	txt[48] = 0x46;
	txt[49] = 0x46;
	txt[51] = 0x46;
	txt[52] = 0x46;
	SendDlgItemMessage(IDC_DAT, LB_DELETESTRING, (WPARAM) Num, 0);
	SendDlgItemMessage(IDC_DAT, LB_INSERTSTRING, (WPARAM) Num, (LPARAM) &txt);
	SetDlgItemText(IDC_EDSTR, _T(""));
	Edited = true;
//Ex:;
   RefreshCS();
}

void CSRWDlg::OnCompare() 
{
	int i=0, j=0, k=0, ADDR=0, m=0;
	DWORD bc=0, d=0;
	HANDLE port;
	byte comm[5]={0x57, 0x00, 0x77, 0x66, 0x0a0};
	int A0=0, A1=0;

	port=CreateFile(lpDevName, GENERIC_READ|GENERIC_WRITE, 0, NULL, OPEN_EXISTING, 0, NULL);
	if(port==INVALID_HANDLE_VALUE) 
	{
		MessageBox("   ","Error",MB_OK);
		goto Ex;
	}

	A0 = IsDlgButtonChecked(IDC_A0);
	A1 = IsDlgButtonChecked(IDC_A1);
	if (A0)
		A0=2;
	if (A1)
		A1=4;
	comm[4] = 0xa0 | A0 | A1;

	SetDlgItemText(IDC_STATUS, _T(" "));
	if (!Power(port, 1))
		MessageBox("Power supply error !", lpProjName, MB_OK);
	PortInit(port);

	WriteFile(port, comm, 5, &bc, NULL);
	PurgeComm(port, PURGE_TXCLEAR|PURGE_RXCLEAR);
	CloseHandle(port);
	SetDlgItemText(IDC_STATUS, _T(" "));
Ex:;
	
}


void RefreshCS(void)
{
	long c=0, i=0;
	for (i=0; i<lpSize; c += DAT[i], i++) {};
	HWND Dlg = (HWND) GetActiveWindow();
	TCHAR	tszMsg[100];
	_sntprintf(tszMsg, 100, _T(": %x"), c);
	SetDlgItemText(Dlg, IDC_CS, tszMsg);
}



void CSRWDlg::OnClearrgn() 
{
	char sFrom[5]={0,0,0,0,0};
	char sTo[5]={0,0,0,0,0};
	int z=0, i=0, j=0;
	int bFrom=0, bTo=0;
	byte b=0;
	GetDlgItemText(IDC_TO, sTo, 5);
	GetDlgItemText(IDC_FROM, sFrom, 5);
	z = strlen(sFrom);
	if (z != 4)
	{
		MessageBox(_T(" .     "), lpProjName, MB_OK);
		goto Ex;
	}
	b=ValHex(sFrom[0]);
	if (b == 0xff)
	{
		TCHAR	tszMsg[50];
		_sntprintf(tszMsg, 50, _T(" .  %d  !"), i);
		MessageBox(tszMsg, lpProjName, MB_OK);
		goto Ex;
	}
	bFrom = b<<4;
	i++;
	b=ValHex(sFrom[1]);
	if (b == 0xff)
	{
		TCHAR	tszMsg[50];
		_sntprintf(tszMsg, 50, _T(" .  %d  !"), i);
		MessageBox(tszMsg, lpProjName, MB_OK);
		goto Ex;
	}
	bFrom += b;
	bFrom =bFrom<<8;
	i++;
	b=ValHex(sFrom[2]);
	if (b == 0xff)
	{
		TCHAR	tszMsg[50];
		_sntprintf(tszMsg, 50, _T(" .  %d  !"), i);
		MessageBox(tszMsg, lpProjName, MB_OK);
		goto Ex;
	}
	bFrom += b<<4;
	b=ValHex(sFrom[3]);
	if (b == 0xff)
	{
		TCHAR	tszMsg[50];
		_sntprintf(tszMsg, 50, _T(" .  %d  !"), i);
		MessageBox(tszMsg, lpProjName, MB_OK);
		goto Ex;
	}
	bFrom += b;

	z = strlen(sTo);
	if (z != 4)
	{
		MessageBox(_T(" .     "), lpProjName, MB_OK);
		goto Ex;
	}
	b=ValHex(sTo[0]);
	if (b == 0xff)
	{
		TCHAR	tszMsg[50];
		_sntprintf(tszMsg, 50, _T(" .  %d  !"), i);
		MessageBox(tszMsg, lpProjName, MB_OK);
		goto Ex;
	}
	bTo = b<<4;
	i++;
	b=ValHex(sTo[1]);
	if (b == 0xff)
	{
		TCHAR	tszMsg[50];
		_sntprintf(tszMsg, 50, _T(" .  %d  !"), i);
		MessageBox(tszMsg, lpProjName, MB_OK);
		goto Ex;
	}
	bTo += b;
	bTo =bTo<<8;
	i++;
	b=ValHex(sTo[2]);
	if (b == 0xff)
	{
		TCHAR	tszMsg[50];
		_sntprintf(tszMsg, 50, _T(" .  %d  !"), i);
		MessageBox(tszMsg, lpProjName, MB_OK);
		goto Ex;
	}
	bTo += b<<4;
	b=ValHex(sTo[3]);
	if (b == 0xff)
	{
		TCHAR	tszMsg[50];
		_sntprintf(tszMsg, 50, _T(" .  %d  !"), i);
		MessageBox(tszMsg, lpProjName, MB_OK);
		goto Ex;
	}
	bTo += b;

	if (bFrom > bTo)
	{
		MessageBox("    !", lpProjName, MB_OK);
		goto Ex;
	}

	if ((bFrom < 0) || (bFrom > lpSize-1))
		bFrom = 0;
	if ((bTo < 0) || (bTo > lpSize-1))
		bTo = lpSize-1;
	SetClearRgn(bFrom, bTo, this->m_hWnd);
	for (i=bFrom; i<=bTo;DAT[i]=0xFF, i++) {};
	FillBuff(this->m_hWnd);
Ex:;	
}


void SetClearRgn(int iFrom, int iTo, HWND Dlg)
{
	int i=0;
	char szStr[5];
	szStr[0] = dhex((iFrom/256) / 16);
	szStr[1] = dhex((iFrom/256) % 16);
	iFrom %=256;
	szStr[2] = dhex(iFrom / 16);
	szStr[3] = dhex(iFrom % 16);
	szStr[4] = 0x00;
	SetDlgItemText(Dlg, IDC_FROM, szStr);

	szStr[0] = dhex((iTo/256) / 16);
	szStr[1] = dhex((iTo/256) % 16);
	iTo %=256;
	szStr[2] = dhex(iTo / 16);
	szStr[3] = dhex(iTo % 16);
	szStr[4] = 0x00;
	SetDlgItemText(Dlg, IDC_TO, szStr);
}



void MakeRecord(TCHAR tszMsg[50])
{
//	HANDLE file;
//	DWORD bc;
//	file = CreateFile(lpLog, GENERIC_READ|GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, 0, NULL);
//	WriteFile(file, tszMsg, 50, &bc, NULL);
//	CloseHandle(file);
}

void CSRWDlg::OnKillfocusFrom() 
{
	CString txt;
	int l=0;
	GetDlgItemText(IDC_FROM,txt);
Lab1:;	
	l=txt.GetLength();
	if (l<4)
		{
		txt.Insert(0,_T("0"));
		goto Lab1;
		}
	SetDlgItemText(IDC_FROM,txt);
}

void CSRWDlg::OnKillfocusTo() 
{
	CString txt;
	int l=0;
	GetDlgItemText(IDC_TO,txt);
Lab1:;	
	l=txt.GetLength();
	if (l<4)
		{
		txt.Insert(0,_T("0"));
		goto Lab1;
		}
	SetDlgItemText(IDC_TO,txt);
}



void CSRWDlg::OnSelchangeDat() 
{
	int Num = SendDlgItemMessage(IDC_DAT, LB_GETCURSEL, 0, 0);
	int adr = Num * 16;
	char szStr[5];
	szStr[0] = dhex((adr/256) / 16);
	szStr[1] = dhex((adr/256) % 16);
	adr %=256;
	szStr[2] = dhex(adr / 16);
	szStr[3] = dhex(adr % 16);
	szStr[4] = 0x00;
	SetDlgItemText(IDC_FROM, szStr);

}


/*
BOOL CALLBACK MyDlgProc(HWND hwndDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	static HBRUSH hBrush;
	HWND hMyComboBox=GetDlgItem(hwndDlg, IDC_FSIZE);
	if (hMyComboBox!=hwndDlg)
		goto Ex;
	
	switch (message)
	{
		case WM_INITDIALOG:
		{
			hBrush=CreateSolidBrush(RGB(255,255,0));
		}
		return true;
		case WM_CTLCOLORLISTBOX:
		case WM_CTLCOLOREDIT:
		{
			SetBkMode((HDC) wParam, TRANSPARENT);
			SetTextColor((HDC) wParam, RGB(200,200,27));
			SetBkColor((HDC) wParam, RGB(255,255,0));
			return	(LRESULT) hBrush;
		}
		return true;
		case WM_DESTROY:
		{
			DeleteObject(hBrush);
		}
		return true;
	}
Ex:;
	return false;
}

*/
